/*============================================================================
 * basic_types.h
 *      Types that are used throughout.  Allows you to globally change things
 *      like the float size in one place.
 *==========================================================================*/

#ifndef _basic_types_h_
#define _basic_types_h_

#define REAL_LARGE              3e38

#define BFALSE          0
#define BTRUE           1

//#include <complex>
#ifdef __NVCC__
#include  <thrust/complex.h>
#else
#include <complex.h>
#endif

typedef unsigned int U32;
typedef signed int S32;
typedef unsigned long int U64;
typedef signed long int S64;

typedef float Real;

#ifdef __NVCC__
typedef thrust::complex<float> Cplx;
#else
typedef std::complex<float> Cplx;
#endif

typedef U32 Uint;
typedef S32 Int;
typedef S32 Bool;

#ifndef __NVCC__
#define __host__
#define __device__
#endif

#define J               (Cplx(0.0,1.0))

#define SQRT(x)         (sqrtf(x))

#define EPS0 (8.854e-12)

#endif /* _basic_types_h_ */
