#ifndef _mem_h_
#define _mem_h_

#include <stdlib.h>
#include "basic_types.h"

inline Bool mallocHost(void **ptr, size_t size, Bool use_gpu)
{
    if (use_gpu)
    {
#ifdef __NVCC__
        return((cudaMallocHost(ptr, size) == cudaSuccess) ? BTRUE : BFALSE );
#else
        return(BFALSE);
#endif
    }
    else
    {
        if ((*ptr = malloc(size)) == 0)
        {
            return(BFALSE);
        }
        else
        {
            return(BTRUE);
        }
    }
}

inline void freeHost(void *ptr, Bool use_gpu)
{
    if (use_gpu)
    {
#ifdef __NVCC__        
        cudaFreeHost(ptr);
#endif
    }
    else
    {
        free(ptr);
    }
}

#endif
